routes/web.php
<?php

use App\Http\Controllers\HomeController;
use App\Http\Controllers\ProductoController;
use App\Http\Controllers\ProductoTiendaController;
use App\Http\Controllers\TiendaController;
use App\Models\Producto;
use Illuminate\Support\Facades\Route;

Route::controller(HomeController::class)->group(function () {
    Route::get('/', 'index')->name('home.index');
    Route::get('/index', 'index')->name('home.index');
});

//rutas de tienda con recurso
Route::resource('tienda', TiendaController::class);

//rutas para tienda
// Route::controller(TiendaController::class)->group(function () {
//     Route::get('/tienda', 'index')->name('tienda.index');
//     Route::get('/tienda/create', 'create')->name('tienda.create');
//     Route::get('/tienda/{id}', 'show')->name('tienda.show');
//     Route::post('/tienda', 'store')->name('tienda.store');
//     Route::get('/tienda/edit/{id}', 'edit')->name('tienda.edit');
//     Route::put('/tienda/{id}', 'update')->name('tienda.update');
//     Route::delete('/tienda/{id}', 'destroy')->name('tienda.destroy');
// });


//rutas de producto con recurso

Route::resource('producto', ProductoController::class);

// //rutas para producto
// Route::controller(ProductoController::class)->group(function () {
//     Route::get('/producto', 'index')->name('producto.index');
//     Route::get('/producto/create', 'create')->name('producto.create');
//     Route::get('/producto/{id}', 'show')->name('producto.show');
//     Route::post('/producto', 'store')->name('producto.store');
//     Route::get('/producto/edit/{id}', 'edit')->name('producto.edit');
//     Route::put('/producto/{id}', 'update')->name('producto.update');
//     Route::delete('/producto/{id}', 'destroy')->name('producto.destroy');
// });

//rutas para productoTienda
// Route::controller(ProductoTiendaController::class)->group(function () {
//     Route::get('/productoTienda', 'index')->name('productoTienda.index');
//     Route::get('/productoTienda/create', 'create')->name('productoTienda.create');
//     Route::get('/productoTienda/{id}', 'show')->name('productoTienda.show');
//     Route::post('/productoTienda', 'store')->name('productoTienda.store');
//     Route::get('/productoTienda/edit/{id}', 'edit')->name('productoTienda.edit');
//     Route::put('/productoTienda/{id}', 'update')->name('productoTienda.update');
//     Route::delete('/productoTienda/{id}', 'destroy')->name('productoTienda.destroy');
// });

//rutas para productotienda con resource
Route::resource('productotienda', ProductotiendaController::class);

app/Models/Productotienda.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Facades\Schema;

class Productotienda extends Model
{
    use HasFactory;

    protected $table = 'productotiendas';

    //campos asignacion masiva
    protected $fillable = [
        'cantidad',
        'producto_id',
        'tienda_id'
    ];

    public static $labels = [
        "cantidad" => "Cantida del producto",
        "producto_id" => "ID del producto",
        "tienda_id" => "ID de la tienda",
        'nombretienda' => 'Nombre de la tienda',
        'nombreproducto' => 'Nombre del producto',      
    ];

    //relaciones con la tabla tienda que es belongsTo y en plural
    public function tienda(): BelongsTo
    {
        return $this->belongsTo(Tienda::class);
    }

    //relaciones con la tabla producto que es belongsTo y en plural
    public function producto(): BelongsTo
    {
        return $this->belongsTo(Producto::class);
    }


    //creo una nueva propiedad en el modelo para ver el nombre de la tienda
    public function getNombretiendaAttribute()
    {
        return $this->tienda->nombre;
    }


    //creo una nueva propiedad en el modelo para ver el nombre del producto
    public function getNombreproductoAttribute()
    {
        return $this->producto->nombre;
    }

    public function getAttributeLabel($attribute)
    {
        return $this->labels[$attribute] ?? $attribute;
    }

    //metodo para obtener los campos de la tabla
    public function getFields()
    {
        return Schema::getColumnListing($this->table);
    }
}

app/Http/Controllers/ProductotiendaController.php
<?php

namespace App\Http\Controllers;

use App\Models\Productotienda;
use Illuminate\Http\Request;

class ProductotiendaController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        $productotienda = Productotienda::paginate(6);

        //dd($productotienda[3]->nombreproducto);

        return view('productotienda.index', ['productotienda' => $productotienda]);
    }



    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }



    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request)
    {
        //
    }



    /**
     * Display the specified resource.
     */
    public function show(Productotienda $productotienda)
    {

        $productotienda->tienda->nombre; //saco el nombre de la tienda
        $productotienda->producto->nombre; //saco el nombre del producto

        return view('productotienda.show', ['productotienda' => $productotienda]);
    }



    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Productotienda $productotienda)
    {
        //
    }



    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, Productotienda $productotienda)
    {
        //
    }



    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Productotienda $productotienda)
    {
        //
    }
}

resources/views/productotienda/index.blade.php
@extends('layouts.main')

@section('titulo', 'Listado de compras')

@section('cabecera')
    {{-- llamamos al componente cabecera --}}
    <x-cabecera subtitulo="Podemos ver todas las compras">
        <i class="fa-solid fa-shop"></i>Listado de compras
    </x-cabecera>
@endsection

@section('contenido')
    @if (session('mensaje'))
        <div class="row m-3">
            <div class="alert alert-info">
                {{ session('mensaje') }}
            </div>
        </div>
    @endif
    {{-- cargamos el componente listview --}}
    <x-listviewrelations :registros="$productotienda" modelo="productotienda" :campos="[
        'cantidad',
        'producto_id',
        'tienda_id',
        'nombretienda',
        'nombreproducto',
        'tienda.nombre',
        'producto.nombre',
        // [
        //     'label' => 'Nombre de la tienda',
        //     'campo' => 'nombre',
        //     'relacion' => 'tienda',
        // ],
        // [
        //     'label' => 'Nombre del producto',
        //     'valor' => function ($modelo) {
        //         return $modelo->tienda->nombre;
        //     },
        // ],
    ]" />
@endsection

resources/views/productotienda/show.blade.php
@extends('layouts.main')

@section('titulo', 'Mostrar')

@section('cabecera')
    <section class="pt-5 container">
        <div class="row py-lg-5">
            <h1 class="display-4 fw-bold lh-1 mb-3 text-white">Ver compra</h1>
            <p class="col-lg-10 fs-4 text-white">
                Estos son los datos de la compra solicitada
            </p>
        </div>
    </section>
@endsection

@section('contenido')
    @if (session('mensaje'))
        <div class="row m-2">
            <div class="alert alert-info">
                {{ session('mensaje') }}
            </div>
        </div>
    @endif
    <div class="row mt-3">
        <div class="col">
            <div class="card shadow-xl">
                <div class="card-body">
                    <h5 class="card-title">
                        {{ $productotienda->id }}
                    </h5>
                    <p class="card-text">
                        ID del producto: {{ $productotienda->producto_id }}
                    </p>
                    <p class="card-text">
                        Nombre del producto: {{ $productotienda->producto->nombre }}
                    </p>
                    <p class="card-text">
                        ID de la tienda: {{ $productotienda->tienda_id }}
                    </p>
                    <p class="card-text">
                        Nombre de la tienda: {{ $productotienda->tienda->nombre }}
                    </p>
                    <p class="card-text">
                        Cantidad: {{ $productotienda->cantidad }}
                    </p>
                    <div class="card-footer">
                        <div class="vertical-align-bottom d-flex justify-content-between align-items-center">
                            <a href="{{ route('productotienda.edit', $productotienda->id) }}"
                                class="btn btn-outline-primary">Editar</a>
                            <form action="{{ route('productotienda.destroy', $productotienda) }}" method="post">
                                @csrf
                                @method('DELETE')
                                <button type="submit" class="btn btn-outline-danger">Eliminar</button>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection